pseudoF = function(X, k,wss){
  nk = length(k)
  n = nrow(X)
  T = sum(scale(X,scale=F)^2)
  W = rep(T, nk)
  for (i in 1:nk){
    set.seed(12345)
    #cli = kmeans(X, k[i],nstart=ns)
    W[i] = wss[i]
  }
  pF = ((T-W)/(k-1))/(W/(n-k))
  return(list(k=k, W=W, pF=pF))
}


gc()

setwd("/esarchive/scratch/molmo/")
#input.data <- matrix(c(1:100000),10000,10)
load("input.data_D2.Rdata")
dim(input.data)

pseudo.F <- list()
input.data2 <- input.data

load("pseudo-F_listD2_new.Rdata")
for(i in 720:1000){
  message(paste("Bootstrapping ",i,sep=""))
  set.seed(i)
  
  subsets <- sample(1:dim(input.data2)[1],size=round(0.95*dim(input.data2)[1]),replace = T)
  input.data <- input.data2[subsets,]
  
  ward_clustering <- hclust(d = dist(input.data),method = "ward.D2")
  
  
  wss <- (nrow(input.data)-1)*sum(apply(input.data,2,var))
  for(x in 1:15){
    wss.sub <- NA
    for(j in 1:x){
      sub.data <- input.data[which(cutree(ward_clustering,k=x)==j),]
      wss.sub[j] <- (nrow(sub.data)-1)*sum(apply(sub.data,2,var))
    }
    wss[x] <- sum(wss.sub)
  }
  
  gc()
  pseudo.F[[i]] <- pseudoF(input.data,1:15,wss)$pF

save(pseudo.F,file="pseudo-F_listD2_new.Rdata")
}

png(filename="pseudoF_bootsD2.png")
plot(pseudo.F[[1]],type="l",main="Pseudo-F, 1000 bootstrapping")
for(i in 2:1000){
  lines(pseudo.F[[i]])
}
dev.off()

